diff -u -r icu/source/test/intltest/regextst.cpp icu.new/source/test/intltest/regextst.cpp
--- icu/source/test/intltest/regextst.cpp	2005-07-05 19:39:00.000000000 +0100
+++ icu.new/source/test/intltest/regextst.cpp	2006-08-10 14:30:06.000000000 +0100
@@ -67,7 +67,6 @@
             if (exec) PerlTests();
             break;
 
-
         default: name = "";
             break; //needed to end loop
     }
@@ -775,6 +774,394 @@
 
     }
 
+    // Conditional matching (there are lots of tests of this in the Perl test suite; we only test
+    // the named group support here because the Perl suite tests the rest)
+    {
+      int32_t       flags = 0;
+      UParseError   pe;
+      UErrorCode    status = U_ZERO_ERROR;
+      
+      // Contrast this with (?(1)a|b), which works for compatibility with Perl
+      UnicodeString re("(?(name)a|b)");
+      REGEX_ASSERT_FAIL (RegexPattern::compile(re, flags, pe, status),
+                         U_REGEX_UNKNOWN_GROUP_NAME);
+
+      // This regexp (based on one from the Perl tests) matches as follows:
+      //
+      //         a a a a a a a a a a ...
+      //         | | | | | | | | | |
+      //         | | | | | | +-----+
+      //         | | | +---+       |
+      //         | +-+     |       +--- Fourth iteration
+      //         |   |     +----------- Third iteration
+      //         |   +----------------- Second iteration
+      //         +--------------------- First iteration
+      //
+      re = "^(?P<name>a(?(name)(?P=name))){4}$";
+      RegexPattern *pat = RegexPattern::compile(re, flags, pe, status);
+      REGEX_CHECK_STATUS;
+
+      UnicodeString data = "aaaaaaaaaa";
+      RegexMatcher *matcher = pat->matcher(data, status);
+      REGEX_CHECK_STATUS;
+      REGEX_ASSERT(matcher->lookingAt(status) == TRUE);
+
+      delete matcher;
+      data = "aaaaaaaaa";
+      matcher = pat->matcher(data, status);
+      REGEX_CHECK_STATUS;
+      REGEX_ASSERT(matcher->lookingAt(status) == FALSE);
+
+      delete matcher;
+      data = "aaaaaaaaaaa";
+      matcher = pat->matcher(data, status);
+      REGEX_CHECK_STATUS;
+      REGEX_ASSERT(matcher->lookingAt(status) == FALSE);
+
+      delete pat;
+
+      // Test a conditional without the false-part
+      re = "^(?P<name>foo)?(?(name)bar)bly$";
+      pat = RegexPattern::compile(re, flags, pe, status);
+      REGEX_CHECK_STATUS;
+      
+      data = "foobarbly";
+      matcher = pat->matcher(data, status);
+      REGEX_CHECK_STATUS;
+      REGEX_ASSERT(matcher->lookingAt(status) == TRUE);
+      delete matcher;
+
+      data = "foobly";
+      matcher = pat->matcher(data, status);
+      REGEX_CHECK_STATUS;
+      REGEX_ASSERT(matcher->lookingAt(status) == FALSE);
+      delete matcher;
+
+      data = "barbly";
+      matcher = pat->matcher(data, status);
+      REGEX_CHECK_STATUS;
+      REGEX_ASSERT(matcher->lookingAt(status) == FALSE);
+      delete matcher;
+
+      data = "bly";
+      matcher = pat->matcher(data, status);
+      REGEX_CHECK_STATUS;
+      REGEX_ASSERT(matcher->lookingAt(status) == TRUE);
+      delete matcher;
+
+      delete pat;
+
+      // Test a repeated conditional
+      re = "^(?P<name>foo)?(?(name)bar){4}bly$";
+      pat = RegexPattern::compile(re, flags, pe, status);
+      REGEX_CHECK_STATUS;
+
+      data = "foobarbarbarbarbly";
+      matcher = pat->matcher(data, status);
+      REGEX_CHECK_STATUS;
+      REGEX_ASSERT(matcher->lookingAt(status) == TRUE);
+      delete matcher;
+
+      data = "foobarbarbly";
+      matcher = pat->matcher(data, status);
+      REGEX_CHECK_STATUS;
+      REGEX_ASSERT(matcher->lookingAt(status) == FALSE);
+      delete matcher;
+
+      data = "foobly";
+      matcher = pat->matcher(data, status);
+      REGEX_CHECK_STATUS;
+      REGEX_ASSERT(matcher->lookingAt(status) == FALSE);
+      delete matcher;
+
+      data = "barbarbarbarbly";
+      matcher = pat->matcher(data, status);
+      REGEX_CHECK_STATUS;
+      REGEX_ASSERT(matcher->lookingAt(status) == FALSE);
+      delete matcher;
+
+      data = "bly";
+      matcher = pat->matcher(data, status);
+      REGEX_CHECK_STATUS;
+      REGEX_ASSERT(matcher->lookingAt(status) == TRUE);
+      delete matcher;
+
+      delete pat;
+
+       // Test a repeated conditional with a false-part
+      re = "^(?P<name>foo)?(?(name)bar|ber){4}bly$";
+      pat = RegexPattern::compile(re, flags, pe, status);
+      REGEX_CHECK_STATUS;
+
+      data = "foobarbarbarbarbly";
+      matcher = pat->matcher(data, status);
+      REGEX_CHECK_STATUS;
+      REGEX_ASSERT(matcher->lookingAt(status) == TRUE);
+      delete matcher;
+
+      data = "foobarbarbly";
+      matcher = pat->matcher(data, status);
+      REGEX_CHECK_STATUS;
+      REGEX_ASSERT(matcher->lookingAt(status) == FALSE);
+      delete matcher;
+
+      data = "foobly";
+      matcher = pat->matcher(data, status);
+      REGEX_CHECK_STATUS;
+      REGEX_ASSERT(matcher->lookingAt(status) == FALSE);
+      delete matcher;
+
+      data = "barbarbarbarbly";
+      matcher = pat->matcher(data, status);
+      REGEX_CHECK_STATUS;
+      REGEX_ASSERT(matcher->lookingAt(status) == FALSE);
+      delete matcher;
+
+      data = "berberberberbly";
+      matcher = pat->matcher(data, status);
+      REGEX_CHECK_STATUS;
+      REGEX_ASSERT(matcher->lookingAt(status) == TRUE);
+      delete matcher;
+
+      data = "bly";
+      matcher = pat->matcher(data, status);
+      REGEX_CHECK_STATUS;
+      REGEX_ASSERT(matcher->lookingAt(status) == FALSE);
+      delete matcher;
+
+      delete pat;
+
+      // Test a conditional with a lookahead expression
+      re = "^(?(?=foo)foobar|f..baz)$";
+      pat = RegexPattern::compile(re, flags, pe, status);
+      REGEX_CHECK_STATUS;
+
+      data = "foobar";
+      matcher = pat->matcher(data, status);
+      REGEX_CHECK_STATUS;
+      REGEX_ASSERT(matcher->lookingAt(status) == TRUE);
+
+      delete matcher;
+      data = "foobaz";
+      matcher = pat->matcher(data, status);
+      REGEX_CHECK_STATUS;
+      REGEX_ASSERT(matcher->lookingAt(status) == FALSE);
+
+      delete matcher;
+      data = "foubaz";
+      matcher = pat->matcher(data, status);
+      REGEX_CHECK_STATUS;
+      REGEX_ASSERT(matcher->lookingAt(status) == TRUE);
+
+      delete matcher;
+      delete pat;
+
+      // Test a conditional with a negated lookahead expression
+      re = "^(?(?!foo)f..baz|foobar)$";
+      pat = RegexPattern::compile(re, flags, pe, status);
+      REGEX_CHECK_STATUS;
+      
+      data = "foobar";
+      matcher = pat->matcher(data, status);
+      REGEX_CHECK_STATUS;
+      REGEX_ASSERT(matcher->lookingAt(status) == TRUE);
+
+      delete matcher;
+      data = "foobaz";
+      matcher = pat->matcher(data, status);
+      REGEX_CHECK_STATUS;
+      REGEX_ASSERT(matcher->lookingAt(status) == FALSE);
+
+      delete matcher;
+      data = "foubaz";
+      matcher = pat->matcher(data, status);
+      REGEX_CHECK_STATUS;
+      REGEX_ASSERT(matcher->lookingAt(status) == TRUE);
+
+      delete matcher;
+      delete pat;
+
+      // Test a conditional with a lookbehind expression
+      re = "^f..(?(?<=foo)bar|b..)$";
+      pat = RegexPattern::compile(re, flags, pe, status);
+      REGEX_CHECK_STATUS;
+      
+      data = "foobar";
+      matcher = pat->matcher(data, status);
+      REGEX_CHECK_STATUS;
+      REGEX_ASSERT(matcher->lookingAt(status) == TRUE);
+
+      delete matcher;
+      data = "foobaz";
+      matcher = pat->matcher(data, status);
+      REGEX_CHECK_STATUS;
+      REGEX_ASSERT(matcher->lookingAt(status) == FALSE);
+
+      delete matcher;
+      data = "foubaz";
+      matcher = pat->matcher(data, status);
+      REGEX_CHECK_STATUS;
+      REGEX_ASSERT(matcher->lookingAt(status) == TRUE);
+
+      delete matcher;
+      delete pat;
+
+      // Test a conditional with a negative lookbehind expression
+      re = "^f..(?(?<!foo)b..|bar)$";
+      pat = RegexPattern::compile(re, flags, pe, status);
+      REGEX_CHECK_STATUS;
+      
+      data = "foobar";
+      matcher = pat->matcher(data, status);
+      REGEX_CHECK_STATUS;
+      REGEX_ASSERT(matcher->lookingAt(status) == TRUE);
+
+      delete matcher;
+      data = "foobaz";
+      matcher = pat->matcher(data, status);
+      REGEX_CHECK_STATUS;
+      REGEX_ASSERT(matcher->lookingAt(status) == FALSE);
+
+      delete matcher;
+      data = "foubaz";
+      matcher = pat->matcher(data, status);
+      REGEX_CHECK_STATUS;
+      REGEX_ASSERT(matcher->lookingAt(status) == TRUE);
+
+      delete matcher;
+      delete pat;
+    }
+
+    // Named capture group
+    {
+        int32_t       flags = 0;
+        UParseError   pe;
+        UErrorCode    status = U_ZERO_ERROR;
+
+        UnicodeString re("01(?P<foo>23(?P<bar>45)67)(?P=bar)"
+                 "(?P<blat>kerpow)?");
+        RegexPattern *pat = RegexPattern::compile(re, flags, pe, status);
+        REGEX_CHECK_STATUS;
+        UnicodeString data = "0123456745";
+        UnicodeString groupNames[2];
+
+        REGEX_ASSERT(pat->groupIndexFromName("foo", status) == 1);
+        REGEX_ASSERT(pat->groupIndexFromName("bar", status) == 2);
+        REGEX_ASSERT(pat->groupCount() == 3);
+        REGEX_ASSERT(pat->getGroupNames(0, groupNames, 0, status) == 3);
+        REGEX_ASSERT(pat->getGroupNames(0, groupNames, 2, status) == 2);
+        REGEX_ASSERT(groupNames[0] == "foo");
+        REGEX_ASSERT(groupNames[1] == "bar");
+        REGEX_ASSERT(pat->getGroupNames(1, groupNames, 1, status) == 1);
+        REGEX_ASSERT(groupNames[0] == "bar");
+        REGEX_ASSERT(pat->getGroupNames(2, groupNames, 2, status) == 1);
+        REGEX_ASSERT(groupNames[0] == "blat");
+        REGEX_CHECK_STATUS;
+
+        RegexMatcher  *matcher = pat->matcher(data, status);
+        REGEX_CHECK_STATUS;
+        REGEX_ASSERT(matcher->lookingAt(status) == TRUE);
+
+        REGEX_ASSERT(matcher->groupIndexFromName("foo", status) == 1);
+        REGEX_ASSERT(matcher->groupIndexFromName("bar", status) == 2);
+        REGEX_ASSERT(matcher->groupCount() == 3);
+        REGEX_ASSERT(matcher->group(0, status) == "0123456745");
+        REGEX_ASSERT(matcher->group(1, status) == "234567");
+        REGEX_ASSERT(matcher->group(2, status) == "45");
+        REGEX_ASSERT(matcher->group("foo", status) == "234567");
+        REGEX_ASSERT(matcher->group("bar", status) == "45");
+        REGEX_ASSERT(matcher->group("blat", status) == "");
+        REGEX_ASSERT(matcher->start("foo", status) == 2);
+        REGEX_ASSERT(matcher->end("foo", status) == 8);
+        REGEX_ASSERT(matcher->start("bar", status) == 4);
+        REGEX_ASSERT(matcher->end("bar", status) == 6);
+        REGEX_CHECK_STATUS;
+        REGEX_ASSERT_FAIL(matcher->group("pants", status),
+                          U_REGEX_UNKNOWN_GROUP_NAME);
+
+        // Test some bad patterns
+        UnicodeString re2("The (?P<name>quick) (?P<name>brown) fox");
+        REGEX_ASSERT_FAIL(RegexPattern::compile(re2, flags, pe, status),
+                          U_REGEX_DUPLICATE_GROUP_NAME);
+
+        UnicodeString re3("The (?P<>bad name)");
+        REGEX_ASSERT_FAIL(RegexPattern::compile(re3, flags, pe, status),
+                          U_REGEX_BAD_GROUP_NAME);
+
+        UnicodeString re4("The (?P=)");
+        REGEX_ASSERT_FAIL(RegexPattern::compile(re4, flags, pe, status),
+                          U_REGEX_BAD_GROUP_NAME);
+
+        UnicodeString re5("The (?P<name>group) (?P=unknown)");
+        REGEX_ASSERT_FAIL(RegexPattern::compile(re5, flags, pe, status),
+                          U_REGEX_UNKNOWN_GROUP_NAME);
+
+        delete matcher;
+        delete pat;
+
+        // Check that backrefs work in case-sensitive and case-insensitive mode
+        UnicodeString re6("This is (?P<name>case) (?:in)?sensitive: (?P=name)");
+
+        pat = RegexPattern::compile(re6, flags | UREGEX_CASE_INSENSITIVE, pe, status);
+        REGEX_CHECK_STATUS;
+        data = "This is case insensitive: CASE";
+        matcher = pat->matcher(data, status);
+        REGEX_CHECK_STATUS;
+        REGEX_ASSERT (matcher->lookingAt(status) == TRUE);
+        REGEX_CHECK_STATUS;
+        delete matcher;
+        data = "This is case insensitive: case";
+        matcher = pat->matcher(data, status);
+        REGEX_CHECK_STATUS;
+        REGEX_ASSERT (matcher->lookingAt(status) == TRUE);
+        REGEX_CHECK_STATUS;
+        delete matcher;
+        delete pat;
+
+        pat = RegexPattern::compile(re6, flags & ~UREGEX_CASE_INSENSITIVE, pe, status);
+        REGEX_CHECK_STATUS;
+        data = "This is case sensitive: CASE";
+        matcher = pat->matcher(data, status);
+        REGEX_CHECK_STATUS;
+        REGEX_ASSERT (matcher->lookingAt(status) == FALSE);
+        REGEX_CHECK_STATUS;
+        delete matcher;
+        data = "This is case sensitive: case";
+        matcher = pat->matcher(data, status);
+        REGEX_CHECK_STATUS;
+        REGEX_ASSERT (matcher->lookingAt(status) == TRUE);
+        REGEX_CHECK_STATUS;
+        delete matcher;
+        delete pat;
+
+        // Forward references should work too; Python doesn't support this,
+        // but we do for consistency with numbered backrefs.  Note that forward
+        // references still work backwards in time, so
+        //
+        //    (?P=foo)(?P<foo>ABC)
+        //
+        // will not match anything (because group "foo" contains nothing).
+        UnicodeString re7("^(?:ABC(?P=foo)|(?P<foo>[a-z]{3}))+$");
+        pat = RegexPattern::compile(re7, flags, pe, status);
+        REGEX_CHECK_STATUS;
+        data = "defABCdefABCdefhijABChij";
+        matcher = pat->matcher(data, status);
+        REGEX_CHECK_STATUS;
+
+        REGEX_ASSERT(matcher->lookingAt(status) == TRUE);
+        REGEX_CHECK_STATUS;
+
+        delete matcher;
+        data = "defABCdefABCdefhijABCdef";
+        matcher = pat->matcher(data, status);
+        REGEX_CHECK_STATUS;
+        REGEX_ASSERT(matcher->lookingAt(status) == FALSE);
+        REGEX_CHECK_STATUS;
+
+        delete matcher;
+        delete pat;
+    }
+
     //
     //  find
     //
